/*
 * Copyright (c) 1996-2004 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as "Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */


/* 
 * $Id: DyninstClient.cpp,v 1.1.1.1 2004/10/18 19:49:47 legendre Exp $
 */

//This application allows the NT/2K box to attach
//to the CE device and perform dyninst functions
//remotely.
//

//#include "stdafx.h"
#include <windows.h>
#include <winsock.h>
#include <winbase.h>
#include "..\..\src\deviceStructs.h"
#include "..\..\src\arch-mips.h" //ccw 3 aug 2000 : this is to parse/count the asm statements
#include "..\..\src\asmExterns.h" //ccw 3 aug 2000 : this will hold the externs for the asm functions
typedef unsigned long Address;//ccw 3 aug 2000

#define PORTNUM         5000          // Port number
#define HOSTNAME        "ppp_peer"   // Server name string
	SOCKET ntMachine;

bool CreateSocket(){

	SOCKADDR_IN destination_sin;        // Server socket address
	PHOSTENT phostent = NULL;           // Points to the HOSTENT structure
                                      // of the server
	WSADATA WSAData;                    // Contains details of the 
                                      // Winsocket implementation
	TCHAR szError[100];                 // Error message string

	// Initialize Winsocket. 
	if (WSAStartup (MAKEWORD(1,1), &WSAData) != 0) 
	{
	 wsprintf (szError, TEXT("WSAStartup failed. Error: %d"), 
            WSAGetLastError ());
	 MessageBox (NULL, szError, TEXT("Error"), MB_OK);
	 return FALSE;
	}

	// Create a TCP/IP socket that is bound to the server.
	if ((ntMachine = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
	{
		wsprintf (szError, TEXT("Allocating socket failed. Error: %d"), 
			      WSAGetLastError ());
		MessageBox (NULL, szError, TEXT("Error"), MB_OK);
		return FALSE;
	}

	// Fill out the server socket's address information.
	destination_sin.sin_family = AF_INET;

	// Retrieve the host information corresponding to the host name.
	if ((phostent = gethostbyname (HOSTNAME)) == NULL) 
	//if ((phostent = gethostbyaddr (HOSTADDR, sizeof(HOSTADDR), AF_INET)) == NULL) 
	{
	    wsprintf (szError, TEXT("Unable to get the host name. Error: %d"), 
		          WSAGetLastError ());
	    MessageBox (NULL, szError, TEXT("Error"), MB_OK);
		closesocket (ntMachine);
	    return FALSE;
	}

	// Assign the socket IP address.
	memcpy ((char FAR *)&(destination_sin.sin_addr), 
          phostent->h_addr, 
          phostent->h_length);

	// Convert to network ordering.
	destination_sin.sin_port = htons (PORTNUM);      

	// Establish a connection to the server socket.
	if (connect (ntMachine, 
               (PSOCKADDR) &destination_sin, 
               sizeof (destination_sin)) == SOCKET_ERROR) 
	{
	    wsprintf (szError, 
              TEXT("Connecting to the server failed. Error: %d"),
              WSAGetLastError ());
		MessageBox (NULL, szError, TEXT("Error"), MB_OK);
	    closesocket (ntMachine);
	    return FALSE;
	}


}

void CloseSocket(SOCKET *ntMachine){
	// Disable receiving on ServerSock.
	shutdown (*ntMachine, 0x00);

	// Close the socket.
	closesocket (*ntMachine);

	WSACleanup ();
}

void LCreateProcess(SOCKET ntMachine){
	struct iCreateProcess *iCP;
	struct oCreateProcess oCP;

	char *buffer;
	int sent, recvd;
	int sizeBuffer;
	BOOL result;
	int totalSize;
	TCHAR commandLine[256];
	TCHAR *commandLinePtr;

	WSASetLastError(0);

	recvd = recv(ntMachine,(char*) &sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	buffer = new char[sizeBuffer];
	//do error checking
	recvd = recv(ntMachine, buffer, sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	iCP = (struct iCreateProcess*) buffer;
	
	if(iCP->lpCommandLineSize == 0){
		commandLinePtr = NULL;

	}else{
		commandLinePtr = commandLine;
		commandLine[0] = '\0';
	}

	result = CreateProcess( (wchar_t*) &(((char*) iCP)[iCP->lpApplicationNameOffset]) ,commandLinePtr,
		NULL, NULL, NULL, iCP->dwCreationFlags, NULL, NULL, NULL, &oCP.lpProcessInformation);

	oCP.retVal = result;
	oCP.retValSize = sizeof(result);

	oCP.lpProcessInformationSize = sizeof(PROCESS_INFORMATION);
	totalSize = sizeof(oCP);

	//do error checking
	sent = send(ntMachine, (char*) &oCP, sizeof(oCP), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	free(buffer);
}

void LOpenProcess(SOCKET ntMachine){
	struct iOpenProcess iOP;
	struct oOpenProcess oOP;

	int sent, recvd;

	WSASetLastError(0);

	recvd = recv(ntMachine, (char *) &iOP, sizeof(iOP),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}

	oOP.retVal = OpenProcess(0, false, iOP.IDProcess);
	oOP.lastError = GetLastError();

	sent = send(ntMachine, (char*)&oOP, sizeof(oOP), 0);

	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}

}

void LWriteProcessMemory(SOCKET ntMachine){
	struct iWriteProcessMemory *iWPM;
	struct oWriteProcessMemory oWPM;

	DWORD numberOfBytesWritten;
	char *buffer;
	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize, retVal;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	buffer = new char[*(int*)sizeBuffer];
	totalSize  = *(int*)sizeBuffer;
	//do error checking

	int received = recv(ntMachine, (char*) buffer, totalSize, 0); //ccw 10 aug 2000
	if(received == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	WSASetLastError(0);
	while(received < totalSize){
		retVal = received;
		received += recv(ntMachine, (char*) &(buffer[retVal]), totalSize - retVal, 0);
		if(received == 0xffffffff){
			recvd = WSAGetLastError();
			DebugBreak();
		}
		WSASetLastError(0);
	}

	//do error checking
           
	iWPM = (struct iWriteProcessMemory*) buffer;

	result = WriteProcessMemory(iWPM->hProcess, iWPM->lpBaseAddress, &iWPM->lpBuffer,
		iWPM->nSize, &numberOfBytesWritten);

	oWPM.retValSize = sizeof(result);
	oWPM.retVal = result;
	oWPM.lpNumberOfBytesWritten = numberOfBytesWritten;
	oWPM.lpNumberOfBytesWrittenSize = sizeof(oWPM.lpNumberOfBytesWritten);
	
	totalSize = sizeof(oWPM);
	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oWPM, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	free(buffer);
}

void LReadProcessMemory(SOCKET ntMachine){
	struct iReadProcessMemory iRPM;
	struct oReadProcessMemory *oRPM;

	DWORD numberOfBytesRead;
	char *buffer;
	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iRPM, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	buffer = new char[sizeof(oReadProcessMemory) + iRPM.nSize ];
	oRPM = (oReadProcessMemory*) buffer;
	result = ReadProcessMemory(iRPM.hProcess, iRPM.lpBaseAddress, &oRPM->lpBuffer,
		iRPM.nSize, &numberOfBytesRead);
	int result2 = GetLastError(); 

	oRPM->retValSize = sizeof(result);
	oRPM->retVal = result;
	oRPM->lpNumberOfBytesRead = numberOfBytesRead;
	oRPM->lpNumberOfBytesReadSize = sizeof(oRPM->lpNumberOfBytesRead);
	
	totalSize = sizeof(oReadProcessMemory) + iRPM.nSize ;
	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	int totalLeft = totalSize;
	while(totalLeft > 0){ //ccw 10 aug 2000
		//send chunks of 1000!
		WSASetLastError(0);
 		sent = send(ntMachine, (char*) &buffer[totalSize-totalLeft], (totalLeft > 999 ? 1000 : totalLeft), 0);
		if(sent == 0xffffffff){
			sent = WSAGetLastError();
			DebugBreak();
		}
		totalLeft -= sent;
	}

	int lerr = WSAGetLastError();
	//do error checking
	free(buffer);
}

void LDebugActiveProcess(SOCKET ntMachine){
	struct iDebugActiveProcess iDAP;
	struct oDebugActiveProcess oDAP;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iDAP, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	result = DebugActiveProcess(iDAP.dwProcessId);

	oDAP.retValSize = sizeof(result);
	oDAP.retVal = result;
	
	totalSize = sizeof(oDAP);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oDAP, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

}

void LGetThreadContext(SOCKET ntMachine){
	struct iGetThreadContext iGTC;
	struct oGetThreadContext oGTC;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iGTC, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	oGTC.lpContext.ContextFlags = CONTEXT_FULL;  //ccw 10 aug 2000
	//SuspendThread(iGTC.hThread); //ccw 10 aug 2000
	oGTC.retVal = GetThreadContext(iGTC.hThread, (struct _CONTEXT*) &oGTC.lpContext);
	result = GetLastError();
	//ResumeThread(iGTC.hThread); //ccw 10 aug 2000
	oGTC.retValSize = sizeof(oGTC.retVal);
	oGTC.lpContextSize = sizeof(CONTEXT);

	totalSize = sizeof(oGTC);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oGTC, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking


}

void LSetThreadContext(SOCKET ntMachine){
	struct iSetThreadContext iSTC;
	struct oSetThreadContext oSTC;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iSTC, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	result = SetThreadContext(iSTC.hThread,  (struct _CONTEXT*) &iSTC.lpContext);

	oSTC.retValSize = sizeof(result);
	oSTC.retVal = result;

	totalSize = sizeof(oSTC);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oSTC, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

}

void LWaitForDebugEvent(SOCKET ntMachine){
	struct iWaitForDebugEvent iWFDE;
	struct oWaitForDebugEvent oWFDE;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iWFDE, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	result = WaitForDebugEvent(&oWFDE.lpDebugEvent,iWFDE.dwMilliseconds);
	
	

	oWFDE.retValSize = sizeof(result);
	oWFDE.retVal = result;
	oWFDE.lpDebugEventSize = sizeof(oWFDE.lpDebugEvent);

	totalSize = sizeof(oWFDE);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oWFDE, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
}

void LContinueDebugEvent(SOCKET ntMachine){
	struct iContinueDebugEvent iCDE;
	struct oContinueDebugEvent oCDE;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd= WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iCDE, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	result = ContinueDebugEvent(iCDE.dwProcessId, iCDE.dwThreadId, iCDE.dwContinueStatus);

	oCDE.retValSize = sizeof(result);
	oCDE.retVal = result;

	totalSize = sizeof(oCDE);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oCDE, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
}


//ccw 3 aug 2000 
void LGetTrampTemplate(SOCKET ntMachine){
//	struct iGetTrampTemplate input;
	struct oGetTrampTemplate *output;

	char *buffer;
	int sent;
	int totalSize, asmSize, recurseAsmSize;

	WSASetLastError(0);
	//this command is odd in that it has no parameters.
	//recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	//do error checking

	
	//do error checking
	//again, no parameters from the NT box
	//recvd = recv(ntMachine, (char*) &iRPM, *(int*) sizeBuffer,0);
	//do error checking


	asmSize = (Address)baseTramp_endTramp - (Address)baseTramp + 10; //kludge for size of baseTramp_endTramp
	recurseAsmSize = (Address) baseNonRecursiveTramp_endTramp - (Address) baseNonRecursiveTramp + 10; //kludge

	buffer = new char[sizeof(oGetTrampTemplate) + asmSize + recurseAsmSize];
	output = (oGetTrampTemplate*) buffer;
	memset(buffer, 0, sizeof(oGetTrampTemplate) + asmSize + recurseAsmSize);



	//ccw 3 aug 2000 : the following two loops are from inst-mips.C, initTramps()
    // base trampoline template
	Address i, base = (Address)baseTramp;
	for (i = base; i < (Address)baseTramp_endTramp; i += INSN_SIZE) {
		Address off = i - base;
		// note: these should not be made into if..else blocks
		// (some of the label values are the same)
		
		if (i == (Address)baseTramp_savePreInsn)
			output->baseTramp_savePreInsOffset = off;

		if (i == (Address)baseTramp_skipPreInsn)
		  output->baseTramp_skipPreInsOffset = off;

		if (i == (Address)baseTramp_globalPreBranch)
		  output->baseTramp_globalPreOffset = off;

		if (i == (Address)baseTramp_localPreBranch)
		  output->baseTramp_localPreOffset = off;
		if (i == (Address)baseTramp_localPreReturn)
		  output->baseTramp_localPreReturnOffset = off;

		if (i == (Address)baseTramp_updateCostInsn)
		  output->baseTramp_updateCostOffset = off;

		if (i == (Address)baseTramp_restorePreInsn)
		  output->baseTramp_restorePreInsOffset = off;

		if (i == (Address)baseTramp_emulateInsn)
		  output->baseTramp_emulateInsOffset = off;

		if (i == (Address)baseTramp_skipPostInsn)
		  output->baseTramp_skipPostInsOffset = off;

		if (i == (Address)baseTramp_savePostInsn)
		  output->baseTramp_savePostInsOffset = off;

		if (i == (Address)baseTramp_globalPostBranch)
		  output->baseTramp_globalPostOffset = off;

		if (i == (Address)baseTramp_localPostBranch)
		  output->baseTramp_localPostOffset = off;
		if (i == (Address)baseTramp_localPostReturn)
		  output->baseTramp_localPostReturnOffset = off;

		if (i == (Address)baseTramp_restorePostInsn)
		  output->baseTramp_restorePostInsOffset = off;

		if (i == (Address)baseTramp_returnInsn)
		  output->baseTramp_returnInsOffset = off;
	}

	output->baseTrampSize = (Address)baseTramp_endTramp - (Address)baseTramp;
	output->baseTrampCost = 8;           // cost if both pre- and post- skipped
	output->baseTrampPrevBaseCost = 135; // cost of [global_pre_branch, update_cost)
	output->baseTrampPostBaseCost = 134; // cost of [global_post_branch, return_insn)
	output->baseTrampPrevInstru = false;
	output->baseTrampPostInstru = false;

	  // base non recursive trampoline template
	base = ( Address )baseNonRecursiveTramp;
	for( i = base;
       i < ( Address )baseNonRecursiveTramp_endTramp;
       i += INSN_SIZE )
    {
      Address off = i - base;
      // note: these should not be made into if..else blocks
      // (some of the label values are the same)

		if( i == ( Address )baseNonRecursiveTramp_savePreInsn )
			output->baseNonRecursiveTramp_savePreInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_skipPreInsn )
			output->baseNonRecursiveTramp_skipPreInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_globalPreBranch )
			output->baseNonRecursiveTramp_globalPreOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_localPreBranch )
			output->baseNonRecursiveTramp_localPreOffset = off;
		if( i == ( Address )baseNonRecursiveTramp_localPreReturn )
			output->baseNonRecursiveTramp_localPreReturnOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_updateCostInsn )
			output->baseNonRecursiveTramp_updateCostOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_restorePreInsn )
			output->baseNonRecursiveTramp_restorePreInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_emulateInsn )
			output->baseNonRecursiveTramp_emulateInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_skipPostInsn )
			output->baseNonRecursiveTramp_skipPostInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_savePostInsn )
			output->baseNonRecursiveTramp_savePostInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_globalPostBranch )
			output->baseNonRecursiveTramp_globalPostOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_localPostBranch )
			output->baseNonRecursiveTramp_localPostOffset = off;
		if( i == ( Address )baseNonRecursiveTramp_localPostReturn )
			output->baseNonRecursiveTramp_localPostReturnOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_restorePostInsn )
			output->baseNonRecursiveTramp_restorePostInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_returnInsn )
			output->baseNonRecursiveTramp_returnInsOffset = off;

		if( i == ( Address )baseNonRecursiveTramp_guardOnPre_begin )
		{
		  output->baseNonRecursiveTramp_guardOnPre_beginOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOffPre_begin )
		{
		  output->baseNonRecursiveTramp_guardOffPre_beginOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOnPost_begin )
		{
		  output->baseNonRecursiveTramp_guardOnPost_beginOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOffPost_begin )
		{
		  output->baseNonRecursiveTramp_guardOffPost_beginOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOnPre_end )
		{
		  output->baseNonRecursiveTramp_guardOnPre_endOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOffPre_end )
		{
		  output->baseNonRecursiveTramp_guardOffPre_endOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOnPost_end )
		{
		  output->baseNonRecursiveTramp_guardOnPost_endOffset = off;
		}
		if( i == ( Address )baseNonRecursiveTramp_guardOffPost_end )
		{
		  output->baseNonRecursiveTramp_guardOffPost_endOffset = off;
		}
    }
	output->baseNonRecursiveTrampSize =
		( Address )baseNonRecursiveTramp_endTramp - ( Address )baseNonRecursiveTramp;
	output->baseNonRecursiveTrampCost = 8;           // cost if both pre- and post- skipped
	output->baseNonRecursiveTrampPrevBaseCost = 135; // cost of [global_pre_branch, update_cost)
	output->baseNonRecursiveTrampPostBaseCost = 134; // cost of [global_post_branch, return_insn)
	output->baseNonRecursiveTrampPrevInstru = false;
	output->baseNonRecursiveTrampPostInstru = false;

	memcpy(&output->buffer, (char*) baseTramp, asmSize);
	memcpy(&(&output->buffer)[asmSize], (char*) baseNonRecursiveTramp, recurseAsmSize);
	output->bufferSize = asmSize;
	output->bufferNRSize = recurseAsmSize;


	totalSize = sizeof(oGetTrampTemplate) + asmSize + recurseAsmSize;
	output->retVal = 1;
	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	int totalLeft = totalSize;
	while(totalLeft > 0){
		//send chunks of 1000!
		WSASetLastError(0);
		sent = send(ntMachine, (char*) &buffer[(totalSize-totalLeft)], (totalLeft > 999 ? 1000 : totalLeft), 0);
		if(sent == 0xffffffff){
			sent = WSAGetLastError();
			DebugBreak();
		}
		totalLeft -= sent;
	}

	//do error checking
	free(buffer);
}

void LResumeThread(SOCKET ntMachine){
	struct iResumeThread iRT;
	struct oResumeThread oRT;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iRT, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	oRT.retVal = ResumeThread(iRT.hThread); 
	result = GetLastError();
	//ResumeThread(iGTC.hThread); //ccw 10 aug 2000
	oRT.retValSize = sizeof(oRT.retVal);

	totalSize = sizeof(oRT);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oRT, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking


}

void LSuspendThread(SOCKET ntMachine){
	struct iResumeThread iST;
	struct oResumeThread oST;

	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iST, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	oST.retVal = SuspendThread(iST.hThread); 
	result = GetLastError();
	//ResumeThread(iGTC.hThread); //ccw 10 aug 2000
	oST.retValSize = sizeof(oST.retVal);

	totalSize = sizeof(oST);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oST, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

}

void LTerminateProcess(SOCKET ntMachine){
	struct iTerminateProcess iTP;
	struct oTerminateProcess oTP;
	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iTP, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	oTP.retVal = TerminateProcess(iTP.hThread, iTP.uExitCode); 
	result = GetLastError();
	oTP.retValSize = sizeof(oTP.retVal);

	totalSize = sizeof(oTP);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oTP, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking


}

void LCloseHandle(SOCKET ntMachine){
	struct iCloseHandle iCH;
	struct oCloseHandle oCH;
	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iCH, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	oCH.retVal = CloseHandle(iCH.hThread); 
	result = GetLastError();
	oCH.retValSize = sizeof(oCH.retVal);

	totalSize = sizeof(oCH);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oCH, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
}


void LFlushInstructionCache(SOCKET ntMachine){
	struct iFlushInstructionCache iFIC;
	struct oFlushInstructionCache oFIC;
	int recvd,sent;
	char sizeBuffer[sizeof(int)];
	BOOL result;
	int totalSize;

	WSASetLastError(0);
	recvd = recv(ntMachine, sizeBuffer,sizeof(sizeBuffer),0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	
	//do error checking
	recvd = recv(ntMachine, (char*) &iFIC, *(int*) sizeBuffer,0);
	if(recvd == 0xffffffff){
		recvd = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

	oFIC.retVal = FlushInstructionCache(iFIC.hProcess,NULL, NULL); 
	result = GetLastError();
	oFIC.retValSize = sizeof(oFIC.retVal);

	totalSize = sizeof(oFIC);

	sent = send(ntMachine, (char*)&totalSize, sizeof(totalSize), 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking
	sent = send(ntMachine, (char*) &oFIC, totalSize, 0);
	if(sent == 0xffffffff){
		sent = WSAGetLastError();
		DebugBreak();
	}
	//do error checking

}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{

	BOOL done=false;
	int recvd;
	char commandBuffer[sizeof(int)];

	//open socket here
	CreateSocket();


	while(!done){
		recvd = recv(ntMachine,commandBuffer, sizeof(commandBuffer),0);	
		//do error checking
		switch(*(int*) commandBuffer){
		case RWriteProcessMemory: 
			LWriteProcessMemory(ntMachine);
	 		break;
		case RCreateProcess:
			LCreateProcess(ntMachine);
			break;
		case ROpenProcess:
			LOpenProcess(ntMachine);
			break; 
		case RReadProcessMemory:
			LReadProcessMemory(ntMachine);
			break;
		case RDebugActiveProcess:
			LDebugActiveProcess(ntMachine);
			break;
		case RGetThreadContext:
			LGetThreadContext(ntMachine);
			break;
		case RSetThreadContext:
			LSetThreadContext(ntMachine);
			break;
		case RWaitForDebugEvent:
			LWaitForDebugEvent(ntMachine);
			break;
		case RContinueDebugEvent:
			LContinueDebugEvent(ntMachine);
			break;
		case RGetTrampTemplate: //ccw 3 aug 2000
			LGetTrampTemplate(ntMachine);
			break;
		case RResumeThread://ccw 24 aug 2000
			LResumeThread(ntMachine);
			break;
		case RSuspendThread://ccw 24 aug 2000
			LSuspendThread(ntMachine);
			break;
		case RTerminateProcess://ccw 31 aug 2000
			LTerminateProcess(ntMachine);
			break;
		case RCloseHandle://ccw 31 aug 2000
			LCloseHandle(ntMachine);
			break;
		case RFlushInstructionCache://ccw 29 sep 2000
			LFlushInstructionCache(ntMachine);
			break;
		case RKill:
			done = true;
			break;
		default:
			break;
		}

	}

	CloseSocket(&ntMachine);
	return 0;
}

