// Automatically generated by Paradyn/igen v4.1-112#0
#ifndef UI_thread_BASE_H
#define UI_thread_BASE_H
#include "pdutil/h/rpcUtil.h"
#include "pdthread/h/thread.h"

#ifdef IGEN_ERR_ASSERT_ON
#ifndef IGEN_ERR_ASSERT
#define IGEN_ERR_ASSERT assert(0)
#endif
#else
#define IGEN_ERR_ASSERT
#endif


 // Errors that can occur internal to igen
#ifndef _IGEN_ERR_DEF
#define _IGEN_ERR_DEF
typedef enum e_IGEN_ERR {
                       igen_no_err=0,
                       igen_encode_err,
                       igen_decode_err,
                       igen_send_err,
                       igen_read_err,
                       igen_request_err,
                       igen_call_err,
                       igen_proto_err
                       }  IGEN_ERR;

#endif
/*
 * input file for igen for User Interface Manager (UIM) interface to Paradyn
 * $Id: UI.I,v 1.1.1.1 2004/10/18 19:49:44 legendre Exp $
 */

#include "paradyn/src/DMthread/DMinclude.h"
#include "paradyn/src/UIthread/Status.h"
#include "performanceConsultant.thread.h"
#include "paradyn/src/VMthread/VMinclude.h"

/* 
 * Handler that gets called when user-selected metric and focus choices
 * are passed back to the requesting visualization thread
 */

typedef int (*chooseMandRCBFunc) (pdvector<metric_focus_pair> *pairList);

/* 
 * Handler that gets called when user choice passed back to requesting 
 *  thread after message display
 */
typedef int (*showMsgCBFunc) (int userChoice);

/* 
 * Handler that gets called when user choice passed back to requesting 
 *  thread after error message display
 */
typedef int (*showErrorCBFunc) (int userChoice);

/*
 * Handler that gets called when user choice passed back to requesting 
 *  thread after menu display.  userChoice is index of selected menu 
 *  item in original list.
 */
typedef int (*chooseMenuItemCBFunc) (int userChoice);

//
// used in batched shg add requests
//
struct uiSHGrequest {
  unsigned srcNodeID;
  unsigned dstNodeID;
  int styleID;
  const char *label;
};

/*
 * igen template for UIM server and client classes 
 */ 



class T_UI  {
public:
typedef enum {
 } class_ids;
struct T_chooseMetricsandResources{ 
chooseMandRCBFunc cb;
pdvector<metric_focus_pair>* pairList;
};
typedef struct T_chooseMetricsandResources T_chooseMetricsandResources;
struct T_showError{ 
int errCode;
const char* errString;
};
typedef struct T_showError T_showError;
struct T_updateStatusLine{ 
const char* sl_name;
const char* msg;
};
typedef struct T_updateStatusLine T_updateStatusLine;
struct T_updateStatusDisplay{ 
int token;
pdstring* item;
};
typedef struct T_updateStatusDisplay T_updateStatusDisplay;
struct T_newPhaseNotification{ 
unsigned phaseID;
const char* phname;
bool with_new_pc;
};
typedef struct T_newPhaseNotification T_newPhaseNotification;
struct T_DAGaddNode{ 
int dagID;
unsigned nodeID;
int styleID;
const char* label;
const char* shgname;
int root;
};
typedef struct T_DAGaddNode T_DAGaddNode;
struct T_DAGaddEdge{ 
int dagID;
unsigned srcID;
unsigned dstID;
int styleID;
const char* label;
};
typedef struct T_DAGaddEdge T_DAGaddEdge;
struct T_DAGaddBatchOfEdges{ 
int dagID;
pdvector<uiSHGrequest>* requests;
unsigned numRequests;
};
typedef struct T_DAGaddBatchOfEdges T_DAGaddBatchOfEdges;
struct T_DAGconfigNode{ 
int dagID;
unsigned nodeID;
int styleID;
};
typedef struct T_DAGconfigNode T_DAGconfigNode;
struct T_requestNodeInfoCallback{ 
unsigned phaseID;
int nodeID;
shg_node_info* theInfo;
bool ok;
};
typedef struct T_requestNodeInfoCallback T_requestNodeInfoCallback;
struct T_CGaddNode{ 
int pid;
resourceHandle parent;
resourceHandle newNode;
const char* shortName;
const char* fullName;
bool isRecursive;
bool shadowNode;
};
typedef struct T_CGaddNode T_CGaddNode;
struct T_callGraphProgramAddedCB{ 
unsigned programId;
resourceHandle newId;
const char* executableName;
const char* shortName;
const char* fullName;
};
typedef struct T_callGraphProgramAddedCB T_callGraphProgramAddedCB;
enum message_tags {
  verify = 3000,
  chooseMetricsandResources_REQ, chooseMetricsandResources_RESP,
  chosenMetricsandResources_REQ, chosenMetricsandResources_RESP,
  registerValidVisis_REQ, registerValidVisis_RESP,
  threadExiting_REQ, threadExiting_RESP,
  showError_REQ, showError_RESP,
  updateStatusLine_REQ, updateStatusLine_RESP,
  createStatusLine_REQ, createStatusLine_RESP,
  createProcessStatusLine_REQ, createProcessStatusLine_RESP,
  destroyStatusLine_REQ, destroyStatusLine_RESP,
  enablePauseOrRun_REQ, enablePauseOrRun_RESP,
  readStartupFile_REQ, readStartupFile_RESP,
  ProcessCmd_REQ, ProcessCmd_RESP,
  allDataSaved_REQ, allDataSaved_RESP,
  resourcesSaved_REQ, resourcesSaved_RESP,
  shgSaved_REQ, shgSaved_RESP,
  updateStatusDisplay_REQ, updateStatusDisplay_RESP,
  newPhaseNotification_REQ, newPhaseNotification_RESP,
  DAGaddNode_REQ, DAGaddNode_RESP,
  DAGaddEdge_REQ, DAGaddEdge_RESP,
  DAGaddBatchOfEdges_REQ, DAGaddBatchOfEdges_RESP,
  DAGconfigNode_REQ, DAGconfigNode_RESP,
  DAGinactivateEntireSearch_REQ, DAGinactivateEntireSearch_RESP,
  requestNodeInfoCallback_REQ, requestNodeInfoCallback_RESP,
  CGaddNode_REQ, CGaddNode_RESP,
  callGraphProgramAddedCB_REQ, callGraphProgramAddedCB_RESP,
  CGDoneAddingNodesForNow_REQ, CGDoneAddingNodesForNow_RESP,
  CloseTkConnection_REQ, CloseTkConnection_RESP,
  showWhereAxisTips_REQ, showWhereAxisTips_RESP,
  showSHGKey_REQ, showSHGKey_RESP,
  useLoops_REQ, useLoops_RESP,
  showSHGTips_REQ, showSHGTips_RESP,
  showSHGTrueNodes_REQ, showSHGTrueNodes_RESP,
  showSHGFalseNodes_REQ, showSHGFalseNodes_RESP,
  showSHGUnknownNodes_REQ, showSHGUnknownNodes_RESP,
  showSHGNeverExpandedNodes_REQ, showSHGNeverExpandedNodes_RESP,
  showSHGActiveNodes_REQ, showSHGActiveNodes_RESP,
  showSHGInactiveNodes_REQ, showSHGInactiveNodes_RESP,
  showSHGShadowNodes_REQ, showSHGShadowNodes_RESP,
  setDeveloperMode_REQ, setDeveloperMode_RESP,
  showTclPrompt_REQ, showTclPrompt_RESP,
  DMready_REQ, DMready_RESP,
  error, last }; 
 typedef enum message_tags message_tags;
};


#endif

