// Automatically generated by Paradyn/igen v4.1-112#0
#ifndef dyninstRPC_xdr_BASE_H
#define dyninstRPC_xdr_BASE_H
#include "pdutil/h/rpcUtil.h"
 
#ifdef IGEN_ERR_ASSERT_ON
#ifndef IGEN_ERR_ASSERT
#define IGEN_ERR_ASSERT assert(0)
#endif
#else
#define IGEN_ERR_ASSERT
#endif


 // Errors that can occur internal to igen
#ifndef _IGEN_ERR_DEF
#define _IGEN_ERR_DEF
typedef enum e_IGEN_ERR {
                       igen_no_err=0,
                       igen_encode_err,
                       igen_decode_err,
                       igen_send_err,
                       igen_read_err,
                       igen_request_err,
                       igen_call_err,
                       igen_proto_err
                       }  IGEN_ERR;

#endif
/*
 * Copyright (c) 1996-2004 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as "Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */

/* $Id: dyninstRPC.I,v 1.1.1.1 2004/10/18 19:49:44 legendre Exp $
 */

#define MetStyleEventCounter	0
#define MetStyleSampledFunction	1

#include "common/h/Types.h"
#include "pdutil/h/mdl.h"
#include "common/h/std_namesp.h"



// trace data streams


/* used by paradynd to inform a change in the status of an application. */
#define procPaused 0
#define procExited 1
typedef u_int processStatus_t;























/* descriptive information about a metric */








typedef
enum
{
    inst_insert_unknown,
    inst_insert_success,
    inst_insert_failure,
    inst_insert_deferred
} inst_insert_result_t;











/*
 * Create a paradynd process.
 *
 */
int createDaemon(pdstring machine,
		 pdstring login,
		 pdstring name,
		 pdvector<pdstring> argv);



class T_dyninstRPC  {
public:
typedef enum {
 mdl_expr_id = 6001, mdl_v_expr_id, mdl_icode_id, mdl_stmt_id, mdl_list_stmt_id, mdl_for_stmt_id, mdl_if_stmt_id, mdl_seq_stmt_id, mdl_instr_stmt_id, mdl_constraint_id, mdl_metric_id} class_ids;
struct batch_buffer_entry{ 
int mid;
double startTimeStamp;
double endTimeStamp;
double value;

   batch_buffer_entry &operator=(const batch_buffer_entry &src) {
      mid = src.mid;
      startTimeStamp = src.startTimeStamp;
      endTimeStamp = src.endTimeStamp;
      value = src.value;
      return *this;
   }
};
typedef struct batch_buffer_entry batch_buffer_entry;
struct trace_batch_buffer_entry{ 
int mid;
u_int length;
byteArray traceRecord;

   trace_batch_buffer_entry &operator=(const trace_batch_buffer_entry &src) {
      mid = src.mid;
      length = src.length;
      traceRecord = src.traceRecord;
      return *this;
   }
};
typedef struct trace_batch_buffer_entry trace_batch_buffer_entry;
class mdl_expr{ 
 public: 
 mdl_expr();

public:
  virtual ~mdl_expr();
  virtual bool apply(mdl_var &ret) = 0;
  virtual bool apply() = 0;
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) = 0;
#endif
public:
virtual bool marshall (XDR * obj);
virtual class_ids getId() const { return mdl_expr_id;}
};
class mdl_v_expr : virtual public mdl_expr { 
 public: 
 mdl_v_expr();
u_int type_;
int int_literal_;
pdstring str_literal_;
pdstring var_;
u_int bin_op_;
u_int u_op_;
mdl_expr* left_;
mdl_expr* right_;
pdvector<mdl_expr*>* args_;
pdvector<pdstring> fields_;
pdvector<u_int> type_walk;
bool do_type_walk_;
bool ok_;

public:
  mdl_v_expr(int int_literal);
  mdl_v_expr(pdstring a_str, bool is_literal);
  mdl_v_expr(mdl_expr* expr, pdvector<pdstring> fields);
  mdl_v_expr(pdstring func_name, pdvector<mdl_expr*> *args);
  mdl_v_expr(u_int bin_op, mdl_expr *left, mdl_expr *right);
  mdl_v_expr(pdstring var, u_int assign_op, mdl_expr* expr);
  mdl_v_expr(u_int u_op, mdl_expr *expr, bool is_preop);
  mdl_v_expr(pdstring var, mdl_expr *index_expr);
  mdl_v_expr(u_int type,
                int intLiteral,
                pdstring strLiteral,
                pdstring var,
                u_int binOp,
                u_int unOp,
                mdl_expr* leftExpr,
                mdl_expr* rightExpr,
                pdvector<mdl_expr*>* args,
                const pdvector<pdstring>& fields,
                const pdvector<u_int>& type_walk,
                bool useTypeWalk,
                bool isOK );
  ~mdl_v_expr();
  bool apply(mdl_var &ret); // non-code-gen version
  bool apply();                 // code-gen version
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) 
  {
    os << "MDL_V_EXPR: var=" << var_ << " do_type_walk=" << do_type_walk_;
    unsigned size = fields_.size(), index;
    if (size) 
    {
      os << "Fields: ";
      for (index=0; index<size; index++) 
        os << fields_[index] << " ";
      os << endl;
    }
  }
#endif
  unsigned int GetType( void ) const                { return type_; }
  int GetIntLiteral( void ) const                   { return int_literal_; }
  pdstring GetStringLiteral( void ) const             { return str_literal_; }
  pdstring GetVar( void ) const                       { return var_; }
  unsigned int GetBinaryOp( void ) const            { return bin_op_; }
  unsigned int GetUnaryOp( void ) const             { return u_op_; }
  const mdl_expr* GetLeftExpression( void ) const   { return left_; }
  const mdl_expr* GetRightExpression( void ) const  { return right_; }
  const pdvector<mdl_expr*>* GetArguments( void ) const  { return args_; }
  const pdvector<pdstring>& GetFields( void ) const   { return fields_; }
  const pdvector<unsigned int>& GetTypeWalks( void ) const { return type_walk;
  }
  bool UseTypeWalk( void ) const                    { return do_type_walk_; } 
   
  bool IsOK( void ) const                           { return ok_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_v_expr_id;}
};
class mdl_icode{ 
 public: 
 mdl_icode();
mdl_expr* if_expr_;
mdl_expr* expr_;

public:
  mdl_icode(mdl_expr *if_expr, mdl_expr *expr);
  virtual ~mdl_icode();
  bool apply();

  const mdl_expr* GetIfExpression( void ) const             { return if_expr_; }
  const mdl_expr* GetExpression( void ) const               { return expr_; }
public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_icode_id;}
};
class mdl_stmt{ 
 public: 
 mdl_stmt();

public:
  virtual ~mdl_stmt() { }
  virtual bool apply(pdvector<const instrDataNode*>& flags) = 0;
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) = 0;
#endif
public:
virtual bool marshall (XDR * obj);
virtual class_ids getId() const { return mdl_stmt_id;}
};
class mdl_list_stmt : virtual public mdl_stmt { 
 public: 
 mdl_list_stmt();
u_int type_;
pdstring id_;
pdvector<pdstring>* elements_;
bool is_lib_;
pdvector<pdstring>* flavor_;

public:
  mdl_list_stmt(u_int type, pdstring ident, pdvector<pdstring> *elems,
		bool is_lib, pdvector<pdstring> *flavor);
  virtual ~mdl_list_stmt();
  virtual bool apply(pdvector<const instrDataNode*>& flags);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

  u_int GetType( void ) const                           { return type_; }
  pdstring GetId( void ) const                            { return id_; }
  const pdvector<pdstring>* GetElements( void ) const     { return elements_; }
  bool IsLib( void ) const                              { return is_lib_; }
  const pdvector<pdstring>* GetFlavors( void ) const      { return flavor_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_list_stmt_id;}
};
class mdl_for_stmt : virtual public mdl_stmt { 
 public: 
 mdl_for_stmt();
mdl_stmt* for_body_;
pdstring index_name_;
mdl_expr* list_expr_;

public:
  mdl_for_stmt(pdstring index_name, mdl_expr *list_exp, mdl_stmt *body);
  virtual ~mdl_for_stmt();
  virtual bool apply(pdvector<const instrDataNode*>& flags);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

  const mdl_stmt* GetBodyStatement( void ) const    { return for_body_; }
  pdstring GetIndexName( void ) const                 { return index_name_; }
  const mdl_expr* GetExpression( void ) const       { return list_expr_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_for_stmt_id;}
};
class mdl_if_stmt : virtual public mdl_stmt { 
 public: 
 mdl_if_stmt();
mdl_expr* expr_;
mdl_stmt* body_;

public:
  mdl_if_stmt(mdl_expr *expr, mdl_stmt *body);
  virtual ~mdl_if_stmt();
  virtual bool apply(pdvector<const instrDataNode*>& flags);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

  const mdl_expr* GetExpression( void ) const       { return expr_; }
  const mdl_stmt* GetBodyStatement( void ) const    { return body_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_if_stmt_id;}
};
class mdl_seq_stmt : virtual public mdl_stmt { 
 public: 
 mdl_seq_stmt();
pdvector<mdl_stmt*>* stmts_;

public:
  mdl_seq_stmt(pdvector<mdl_stmt*> *stmts);
  virtual ~mdl_seq_stmt();
  virtual bool apply(pdvector<const instrDataNode*>& flags);
#ifdef NO_MDL_PRINT
  virtual void print(ostream&) { }
#endif

  const pdvector<mdl_stmt*>* GetStatements( void ) const  { return stmts_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_seq_stmt_id;}
};
class mdl_instr_stmt : virtual public mdl_stmt { 
 public: 
 mdl_instr_stmt();
u_int position_;
mdl_expr* point_expr_;
pdvector<mdl_icode*>* icode_reqs_;
u_int where_instr_;
bool constrained_;

public:
  mdl_instr_stmt(u_int pos, mdl_expr *point_expr, pdvector<mdl_icode*> *i_reqs,
		 unsigned where_instr, bool constrained);
  virtual ~mdl_instr_stmt();
  virtual bool apply(pdvector<const instrDataNode*>& flags);
#ifdef NO_MDL_PRINT
  virtual void print(ostream& os) {
    os << "MDL_INSTR_STMT: constrained=" << constrained_ << " ";
    point_expr_->print(os);
  }
#endif

  unsigned int GetPosition( void ) const                { return position_; }
  const mdl_expr* GetExpression( void ) const           { return point_expr_; }

  const pdvector<mdl_icode*>* GetInstrumentation( void ) const  
                                                        { return icode_reqs_; }
  unsigned int GetInstrLoc( void ) const                { return where_instr_; }
  bool IsConstrained( void ) const                      { return constrained_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_instr_stmt_id;}
};
class mdl_constraint{ 
 public: 
 mdl_constraint();
pdstring id_;
pdvector<pdstring>* match_path_;
pdvector<mdl_stmt*>* stmts_;
bool replace_;
u_int data_type_;
u_int hierarchy_;
u_int type_;

public:
  mdl_constraint(pdstring id, pdvector<pdstring> *match_path,
		 pdvector<mdl_stmt*> *stmts, bool replace, u_int d_type,
		 bool& error);
  mdl_constraint(pdstring id, pdvector<pdstring> *match_path,
		 pdvector<mdl_stmt*> *stmts, bool replace, u_int d_type,
		 u_int hierarchy, u_int type);
  virtual ~mdl_constraint();
  bool apply();
  bool replace();
  pdstring id();

#ifdef NO_MDL_PRINT
   friend ostream& operator<< (ostream& os, const mdl_constraint& cons) {
     os << "\nConstraint: " << cons.id_ << " ";
     unsigned size, index;
     if (cons.match_path_) {
       size = cons.match_path_->size();
       for (index=0; index<size; index++) os << (*cons.match_path_)[index] << "/";
       os << endl;
     }
     os << "Replace=" << cons.replace_ << " Data_type=" << cons.data_type_ << " Hierarchy=" 
       << cons.hierarchy_ << " Type=" << cons.type_ << endl;
    if (cons.stmts_) {
      size = cons.stmts_->size();
      os << "Statements\n";
      for (index=0; index<size; index++) {
	(*cons.stmts_)[index]->print(os);
	os << " ";
      }
    }
    return os;
   }
#endif

  pdstring GetId( void ) const                            { return id_; }
  const pdvector<pdstring>* GetMatchPath( void ) const    { return match_path_; }
  const pdvector<mdl_stmt*>* GetStatements( void ) const    { return stmts_; }
  bool IsReplacing( void ) const                            { return replace_; }
  u_int GetDataType( void ) const                       { return data_type_; }
  u_int GetHierarchy( void ) const                      { return hierarchy_; }
  u_int GetType( void ) const                           { return type_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_constraint_id;}
};
class mdl_metric{ 
 public: 
 mdl_metric();
pdstring id_;
pdstring name_;
pdstring units_;
u_int agg_op_;
u_int style_;
u_int type_;
pdstring hwcntr_;
pdvector<mdl_stmt*>* stmts_;
pdvector<pdstring>* flavors_;
pdvector<mdl_constraint*>* constraints_;
pdvector<pdstring>* temp_ctr_;
bool developerMode_;
int unitstype_;

public:
  mdl_metric(pdstring id, pdstring name, pdstring units,
	     u_int agg, u_int style, u_int type, pdstring hwcntr, 
	     pdvector<mdl_stmt*> *mv, pdvector<pdstring> *flavs, 
	     pdvector<mdl_constraint*> *cons,
	     pdvector<pdstring> *temp_c, bool developerMode,int unitstype);
  virtual ~mdl_metric();
#ifdef NO_MDL_PRINT
  friend ostream& operator<< (ostream &os, const mdl_metric& met) {
    os << "\nMetric: " << met.id_ << " " << met.name_ << " agg_op=" << met.agg_op_ << " style=" 
      << met.style_ << " type=" << met.type_ << endl;
    unsigned size, index;
    if (met.stmts_) {
      size = met.stmts_->size();
      os << "Statements\n";
      for (index=0; index<size; index++) {
	(*met.stmts_)[index]->print(os);
	 os << " ";
      }
    }
    if (met.constraints_) {
      size = met.constraints_->size();
      os << "Constraints\n";
      for (index=0; index<size; index++) {
	os << *((*met.constraints_)[index]) << " ";
      }
    }
    return os;
  }
#endif

  bool apply();

  pdstring GetId( void ) const                    { return id_; }
  pdstring GetName( void ) const                  { return name_; }
  pdstring GetUnits( void ) const                 { return units_; }
  u_int GetAggOp( void ) const                  { return agg_op_; }
  u_int GetStyle( void ) const                  { return style_; }
  u_int GetType( void ) const                   { return type_; }
  pdstring GetHWCounterEvent( void ) const        { return hwcntr_; }
  const pdvector<mdl_stmt*>* GetStatements( void ) const    { return stmts_; }
  const pdvector<pdstring>* GetFlavors( void ) const          { return flavors_; }
  const pdvector<mdl_constraint*>* GetConstraints( void ) const 
                                                { return constraints_; }
  const pdvector<pdstring>* GetTempCounters( void ) const     { return temp_ctr_;}
  bool IsDeveloperMode( void ) const            { return developerMode_; }
  int GetUnitsType( void ) const                { return unitstype_; }

public:
bool marshall (XDR * obj);
class_ids getId() const { return mdl_metric_id;}
};
struct metricInfo{ 
pdstring name;
int style;
int aggregate;
pdstring units;
bool developerMode;
int unitstype;
u_int handle;
};
typedef struct metricInfo metricInfo;
struct focusStruct{ 
pdvector<u_int> focus;
};
typedef struct focusStruct focusStruct;
struct resourceInfoCallbackStruct{ 
u_int temporaryId;
pdvector<pdstring> resource_name;
pdstring abstraction;
u_int type;
u_int mdlType;
};
typedef struct resourceInfoCallbackStruct resourceInfoCallbackStruct;
struct indivInstResponse{ 
u_int mi_id;
u_int status;
pdstring emsg;

    indivInstResponse( u_int mid = 0,
                        inst_insert_result_t _status = inst_insert_failure,
                        pdstring msg = "" )
      : mi_id( mid ),
        status( _status ),
        emsg( msg )
    { }
};
typedef struct indivInstResponse indivInstResponse;
struct instResponse{ 
u_int request_id;
u_int daemon_id;
pdvector<indivInstResponse> rinfo;

    instResponse( u_int reqId = 0, u_int did = 0 )
      : request_id( reqId ),
      daemon_id( did )
    { }
};
typedef struct instResponse instResponse;
struct rawMDL{ 
pdstring buf;

    rawMDL( pdstring _buf = "" )
      : buf( _buf )
    { }
};
typedef struct rawMDL rawMDL;
struct T_addExecutable{ 
pdvector<pdstring> argv;
pdstring dir;
};
typedef struct T_addExecutable T_addExecutable;
struct T_attach{ 
pdstring path;
int pid;
int afterAttach;
};
typedef struct T_attach T_attach;
struct T_detachProgram{ 
int program;
bool pause;
};
typedef struct T_detachProgram T_detachProgram;
struct T_newProgramCallbackFunc{ 
int pid;
pdvector<pdstring> argv;
pdstring machine;
bool calledFromExec;
bool wantToInitiallyRun;
};
typedef struct T_newProgramCallbackFunc T_newProgramCallbackFunc;
struct T_showErrorCallback{ 
int errCode;
pdstring errString;
pdstring hostName;
};
typedef struct T_showErrorCallback T_showErrorCallback;
struct T_batchSampleDataCallbackFunc{ 
int program;
pdvector<batch_buffer_entry> theBatchBuffer;
};
typedef struct T_batchSampleDataCallbackFunc T_batchSampleDataCallbackFunc;
struct T_batchTraceDataCallbackFunc{ 
int program;
pdvector<trace_batch_buffer_entry> theTraceBatchBuffer;
};
typedef struct T_batchTraceDataCallbackFunc T_batchTraceDataCallbackFunc;
struct T_cpDataCallbackFunc{ 
int program;
double timeStamp;
int context;
double total;
double share;
};
typedef struct T_cpDataCallbackFunc T_cpDataCallbackFunc;
struct T_setDaemonStartTime{ 
int program;
double startTime;
};
typedef struct T_setDaemonStartTime T_setDaemonStartTime;
struct T_AddCallGraphNodeCallback{ 
pdstring exe_name;
pdstring resource;
};
typedef struct T_AddCallGraphNodeCallback T_AddCallGraphNodeCallback;
struct T_AddCallGraphStaticChildrenCallback{ 
pdstring exe_name;
pdstring resource;
pdvector<pdstring> children;
};
typedef struct T_AddCallGraphStaticChildrenCallback T_AddCallGraphStaticChildrenCallback;
struct T_CallGraphSetEntryFuncCallback{ 
pdstring exe_name;
pdstring entry_func;
int tid;
};
typedef struct T_CallGraphSetEntryFuncCallback T_CallGraphSetEntryFuncCallback;
struct T_AddCallGraphDynamicChildCallback{ 
pdstring exe_name;
pdstring parent;
pdstring child;
};
typedef struct T_AddCallGraphDynamicChildCallback T_AddCallGraphDynamicChildCallback;
struct T_resourceInfoResponse{ 
pdvector<u_int> temporaryIds;
pdvector<u_int> resourceIds;
};
typedef struct T_resourceInfoResponse T_resourceInfoResponse;
struct T_setTracking{ 
u_int resource_id;
bool var_32;
};
typedef struct T_setTracking T_setTracking;
struct T_enableDataCollection{ 
pdvector<focusStruct> focus;
pdvector<pdstring> metric;
pdvector<u_int> mi_ids;
u_int daemon_id;
u_int request_id;
};
typedef struct T_enableDataCollection T_enableDataCollection;
struct T_enableDataCollection2{ 
pdvector<u_int> focus;
pdstring metric;
int id;
u_int daemon_id;
};
typedef struct T_enableDataCollection2 T_enableDataCollection2;
struct T_getPredictedDataCostCallback{ 
u_int id;
u_int req_id;
float val;
u_int clientID;
};
typedef struct T_getPredictedDataCostCallback T_getPredictedDataCostCallback;
struct T_getPredictedDataCost{ 
u_int id;
u_int req_id;
pdvector<u_int> focus;
pdstring metric;
u_int clientID;
};
typedef struct T_getPredictedDataCost T_getPredictedDataCost;
struct T_applicationIO{ 
int pid;
int len;
pdstring line;
};
typedef struct T_applicationIO T_applicationIO;
struct T_reportSelf{ 
pdstring machine;
pdstring program;
int pid;
pdstring flavor;
};
typedef struct T_reportSelf T_reportSelf;
struct T_processStatus{ 
int pid;
u_int procstat;
};
typedef struct T_processStatus T_processStatus;
enum message_tags {
  verify = 4000,
  addExecutable_REQ, addExecutable_RESP,
  attach_REQ, attach_RESP,
  startProgram_REQ, startProgram_RESP,
  pauseProgram_REQ, pauseProgram_RESP,
  pauseApplication_REQ, pauseApplication_RESP,
  continueProgram_REQ, continueProgram_RESP,
  continueApplication_REQ, continueApplication_RESP,
  detachProgram_REQ, detachProgram_RESP,
  MonitorDynamicCallSites_REQ, MonitorDynamicCallSites_RESP,
  newProgramCallbackFunc_REQ, newProgramCallbackFunc_RESP,
  showErrorCallback_REQ, showErrorCallback_RESP,
  batchSampleDataCallbackFunc_REQ, batchSampleDataCallbackFunc_RESP,
  batchTraceDataCallbackFunc_REQ, batchTraceDataCallbackFunc_RESP,
  cpDataCallbackFunc_REQ, cpDataCallbackFunc_RESP,
  setDaemonStartTime_REQ, setDaemonStartTime_RESP,
  setInitialActualValueFE_REQ, setInitialActualValueFE_RESP,
  resourceInfoCallback_REQ, resourceInfoCallback_RESP,
  severalResourceInfoCallback_REQ, severalResourceInfoCallback_RESP,
  CallGraphAddProgramCallback_REQ, CallGraphAddProgramCallback_RESP,
  AddCallGraphNodeCallback_REQ, AddCallGraphNodeCallback_RESP,
  AddCallGraphStaticChildrenCallback_REQ, AddCallGraphStaticChildrenCallback_RESP,
  CallGraphSetEntryFuncCallback_REQ, CallGraphSetEntryFuncCallback_RESP,
  CallGraphFillDone_REQ, CallGraphFillDone_RESP,
  CallGraphAddDynamicCallSiteCallback_REQ, CallGraphAddDynamicCallSiteCallback_RESP,
  AddCallGraphDynamicChildCallback_REQ, AddCallGraphDynamicChildCallback_RESP,
  resourceInfoResponse_REQ, resourceInfoResponse_RESP,
  resourceBatchMode_REQ, resourceBatchMode_RESP,
  retiredResource_REQ, retiredResource_RESP,
  newMetricCallback_REQ, newMetricCallback_RESP,
  setSampleRate_REQ, setSampleRate_RESP,
  setTracking_REQ, setTracking_RESP,
  enableDataCollection_REQ, enableDataCollection_RESP,
  enableDataCollection2_REQ, enableDataCollection2_RESP,
  enableDataCallback_REQ, enableDataCallback_RESP,
  getPredictedDataCostCallback_REQ, getPredictedDataCostCallback_RESP,
  disableDataCollection_REQ, disableDataCollection_RESP,
  endOfDataCollection_REQ, endOfDataCollection_RESP,
  getPredictedDataCost_REQ, getPredictedDataCost_RESP,
  getAvailableMetrics_REQ, getAvailableMetrics_RESP,
  applicationIO_REQ, applicationIO_RESP,
  reportStatus_REQ, reportStatus_RESP,
  getStatus_REQ, getStatus_RESP,
  coreProcess_REQ, coreProcess_RESP,
  reportSelf_REQ, reportSelf_RESP,
  reportSelfDone_REQ, reportSelfDone_RESP,
  processStatus_REQ, processStatus_RESP,
  printStats_REQ, printStats_RESP,
  send_mdl_REQ, send_mdl_RESP,
  getTime_REQ, getTime_RESP,
  error, last }; 
 typedef enum message_tags message_tags;
typedef struct buf_struct {
  void *data_ptr;
  message_tags data_type;
} buf_struct;
};

inline bool P_xdr_send(XDR *xdr, const T_dyninstRPC::message_tags &tag) {
   return P_xdr_send(xdr, (int32_t)tag);
}
inline bool P_xdr_recv(XDR *xdr, T_dyninstRPC::message_tags &tag) {
   int32_t tag_int;
   if (!P_xdr_recv(xdr, tag_int)) return false;
   tag = (T_dyninstRPC::message_tags)tag_int;
   return true;
}

bool P_xdr_send(XDR*, const T_dyninstRPC::batch_buffer_entry&);
bool P_xdr_recv(XDR*, T_dyninstRPC::batch_buffer_entry&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::trace_batch_buffer_entry&);
bool P_xdr_recv(XDR*, T_dyninstRPC::trace_batch_buffer_entry&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_expr *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_expr *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_v_expr&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_v_expr&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_v_expr *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_v_expr *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_icode&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_icode&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_icode *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_icode *&data);


bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_list_stmt&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_list_stmt&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_list_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_list_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_for_stmt&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_for_stmt&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_for_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_for_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_if_stmt&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_if_stmt&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_if_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_if_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_seq_stmt&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_seq_stmt&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_seq_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_seq_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_instr_stmt&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_instr_stmt&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_instr_stmt *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_instr_stmt *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_constraint&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_constraint&);
 // space for data (2nd param) will be allocated but uninitialized
bool P_xdr_send(XDR *obj, T_dyninstRPC::mdl_constraint *data);
bool P_xdr_recv(XDR *obj, T_dyninstRPC::mdl_constraint *&data);


bool P_xdr_send(XDR*, const T_dyninstRPC::mdl_metric&);
bool P_xdr_recv(XDR*, T_dyninstRPC::mdl_metric&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::metricInfo&);
bool P_xdr_recv(XDR*, T_dyninstRPC::metricInfo&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::focusStruct&);
bool P_xdr_recv(XDR*, T_dyninstRPC::focusStruct&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::resourceInfoCallbackStruct&);
bool P_xdr_recv(XDR*, T_dyninstRPC::resourceInfoCallbackStruct&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::indivInstResponse&);
bool P_xdr_recv(XDR*, T_dyninstRPC::indivInstResponse&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::instResponse&);
bool P_xdr_recv(XDR*, T_dyninstRPC::instResponse&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::rawMDL&);
bool P_xdr_recv(XDR*, T_dyninstRPC::rawMDL&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_addExecutable&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_addExecutable&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_attach&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_attach&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_detachProgram&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_detachProgram&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_newProgramCallbackFunc&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_newProgramCallbackFunc&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_showErrorCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_showErrorCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_batchSampleDataCallbackFunc&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_batchSampleDataCallbackFunc&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_batchTraceDataCallbackFunc&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_batchTraceDataCallbackFunc&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_cpDataCallbackFunc&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_cpDataCallbackFunc&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_setDaemonStartTime&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_setDaemonStartTime&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_AddCallGraphNodeCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_AddCallGraphNodeCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_AddCallGraphStaticChildrenCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_AddCallGraphStaticChildrenCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_CallGraphSetEntryFuncCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_CallGraphSetEntryFuncCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_AddCallGraphDynamicChildCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_AddCallGraphDynamicChildCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_resourceInfoResponse&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_resourceInfoResponse&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_setTracking&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_setTracking&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_enableDataCollection&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_enableDataCollection&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_enableDataCollection2&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_enableDataCollection2&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_getPredictedDataCostCallback&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_getPredictedDataCostCallback&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_getPredictedDataCost&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_getPredictedDataCost&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_applicationIO&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_applicationIO&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_reportSelf&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_reportSelf&);
 // space for data (2nd param) will be allocated but uninitialized


bool P_xdr_send(XDR*, const T_dyninstRPC::T_processStatus&);
bool P_xdr_recv(XDR*, T_dyninstRPC::T_processStatus&);
 // space for data (2nd param) will be allocated but uninitialized


#endif

